searchNodes=[{"doc":"Implementation of the Windows PE executable format for reading and writing PE binaries. Most struct member names are taken directly from the windows documentation: https://docs.microsoft.com/en-us/windows/win32/debug/pe-format This library has been created specifically to archieve the following: Update the PE checksum in erl.exe after making changes Insert a Microsoft manifest file after compilation: https://docs.microsoft.com/de-de/windows/win32/sbscs/application-manifests Insert an Executable Icon after compilation","ref":"LibPE.html","title":"LibPE","type":"module"},{"doc":"","ref":"LibPE.html#encode/1","title":"LibPE.encode/1","type":"function"},{"doc":"","ref":"LibPE.html#get_resources/1","title":"LibPE.get_resources/1","type":"function"},{"doc":"","ref":"LibPE.html#parse_file/1","title":"LibPE.parse_file/1","type":"function"},{"doc":"","ref":"LibPE.html#parse_string/1","title":"LibPE.parse_string/1","type":"function"},{"doc":"","ref":"LibPE.html#set_resource/5","title":"LibPE.set_resource/5","type":"function"},{"doc":"","ref":"LibPE.html#set_resources/2","title":"LibPE.set_resources/2","type":"function"},{"doc":"Update the PE image checksum of a PE file.","ref":"LibPE.html#update_checksum/1","title":"LibPE.update_checksum/1","type":"function"},{"doc":"Update the section &amp; certificate layout after a section size has been changed","ref":"LibPE.html#update_layout/1","title":"LibPE.update_layout/1","type":"function"},{"doc":"Elixir implementation of the PE checksum algorithm by David N. Cutler 1993 from https://bytepointer.com/resources/microsoft_pe_checksum_algo_distilled.htm","ref":"LibPE.Checksum.html","title":"LibPE.Checksum","type":"module"},{"doc":"binary_size is provided so embedded checksum values can be removed before running and added afterwards again.","ref":"LibPE.Checksum.html#checksum/2","title":"LibPE.Checksum.checksum/2","type":"function"},{"doc":"Parses windows resource tables By convention these are always three levels: Type &gt; Name &gt; Language","ref":"LibPE.ResourceTable.html","title":"LibPE.ResourceTable","type":"module"},{"doc":"","ref":"LibPE.ResourceTable.html#dump/1","title":"LibPE.ResourceTable.dump/1","type":"function"},{"doc":"","ref":"LibPE.ResourceTable.html#encode/2","title":"LibPE.ResourceTable.encode/2","type":"function"},{"doc":"","ref":"LibPE.ResourceTable.html#parse/2","title":"LibPE.ResourceTable.parse/2","type":"function"},{"doc":"Allows updating a resources. At the moment this call is destructive as it does not allows defining more than one name or language per resource entry. Each defined resource entry set with set_resource will have it's PE name set to 1 and it's language to the provided language code by default 1033 Example: LibPE.ResourceTable.set_resource(table, &quot;RT_MANIFEST&quot;, manifest) Known resources types are: { &quot;RT_ACCELERATOR&quot; , 9 , &quot;Accelerator table.&quot; } , { &quot;RT_ANICURSOR&quot; , 21 , &quot;Animated cursor.&quot; } , { &quot;RT_ANIICON&quot; , 22 , &quot;Animated icon.&quot; } , { &quot;RT_BITMAP&quot; , 2 , &quot;Bitmap resource.&quot; } , { &quot;RT_CURSOR&quot; , 1 , &quot;Hardware-dependent cursor resource.&quot; } , { &quot;RT_DIALOG&quot; , 5 , &quot;Dialog box.&quot; } , { &quot;RT_DLGINCLUDE&quot; , 17 , &quot;Allows a resource editing tool to associate a string with an .rc file. Typically, the string is the name of the header file that provides symbolic names. The resource compiler parses the string but otherwise ignores the value. For example,&quot; } , { &quot;RT_FONT&quot; , 8 , &quot;Font resource.&quot; } , { &quot;RT_FONTDIR&quot; , 7 , &quot;Font directory resource.&quot; } , { &quot;RT_GROUP_CURSOR&quot; , 12 , &quot;Hardware-independent cursor resource.&quot; } , { &quot;RT_GROUP_ICON&quot; , 14 , &quot;Hardware-independent icon resource.&quot; } , { &quot;RT_HTML&quot; , 23 , &quot;HTML resource.&quot; } , { &quot;RT_ICON&quot; , 3 , &quot;Hardware-dependent icon resource.&quot; } , { &quot;RT_MANIFEST&quot; , 24 , &quot;Side-by-Side Assembly Manifest.&quot; } , { &quot;RT_MENU&quot; , 4 , &quot;Menu resource.&quot; } , { &quot;RT_MESSAGETABLE&quot; , 11 , &quot;Message-table entry.&quot; } , { &quot;RT_PLUGPLAY&quot; , 19 , &quot;Plug and Play resource.&quot; } , { &quot;RT_RCDATA&quot; , 10 , &quot;Application-defined resource (raw data).&quot; } , { &quot;RT_STRING&quot; , 6 , &quot;String-table entry.&quot; } , { &quot;RT_VERSION&quot; , 16 , &quot;Version resource.&quot; } , { &quot;RT_VXD&quot; , 20 , &quot;VXD.&quot; }","ref":"LibPE.ResourceTable.html#set_resource/5","title":"LibPE.ResourceTable.set_resource/5","type":"function"},{"doc":"SYNTAX: mix pe.checksum &lt;filename&gt; (&lt;filename&gt;...) pe.checksum checks the PE-checksum of the given pe files.","ref":"Mix.Tasks.Pe.Checksum.html","title":"Mix.Tasks.Pe.Checksum","type":"task"},{"doc":"SYNTAX: mix pe.dump (--raw) &lt;filename&gt; (&lt;filename&gt;...) pe.dump dumps the contents of a PE file.","ref":"Mix.Tasks.Pe.Dump.html","title":"Mix.Tasks.Pe.Dump","type":"task"},{"doc":"SYNTAX: mix pe.update (options) &lt;filename&gt; pe.update updates the PE-checksum of the given pe file and additionally can add resources to it if needed. Options are: - h | - help This help -- set - icon &lt; filename &gt; Embeds a given side - by - side manifest -- set - manifest &lt; filename &gt; Embeds a given application icon -- set - resource &lt; type &gt; &lt; filename &gt; Embeds any resources type Known resources types are: &quot;RT_ACCELERATOR&quot;, &quot;RT_ANICURSOR&quot;, &quot;RT_ANIICON&quot;, &quot;RT_BITMAP&quot;, &quot;RT_CURSOR&quot;, &quot;RT_DIALOG&quot;, &quot;RT_DLGINCLUDE&quot;, &quot;RT_FONT&quot;, &quot;RT_FONTDIR&quot;, &quot;RT_GROUP_CURSOR&quot;, &quot;RT_GROUP_ICON&quot;, &quot;RT_HTML&quot;, &quot;RT_ICON&quot;, &quot;RT_MANIFEST&quot;, &quot;RT_MENU&quot;, &quot;RT_MESSAGETABLE&quot;, &quot;RT_PLUGPLAY&quot;, &quot;RT_RCDATA&quot;, &quot;RT_STRING&quot;, &quot;RT_VERSION&quot;, &quot;RT_VXD&quot;","ref":"Mix.Tasks.Pe.Update.html","title":"Mix.Tasks.Pe.Update","type":"task"},{"doc":"Copyright (c) 2021 Dominic Letz Permission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the &quot;Software&quot;), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions: The above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software. THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"Library and mix tasks to read and update Windows PE file resources. Based on https://docs.microsoft.com/en-us/windows/win32/debug/pe-format Only tested/needed with .exe files so far.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"To check an existing PE file (.exe) mix pe.checksum &lt;filename.exe&gt; To update the checksum: mix pe.update &lt;filename.exe&gt; To list all resources in a file: mix pe.dump &lt;filename.exe&gt; To set an icon resource (and update the checksum): mix pe.update --set-icon &lt;icon.png&gt; &lt;filename.exe&gt;","ref":"readme.html#example-usage","title":"Overview - Example Usage","type":"extras"},{"doc":"To add LibPE to your build steps and make the tasks availabe add libpe to your list of dependencies in mix.exs : def deps do [ { :libpe , &quot;~&gt; 1.0.0&quot; , only : :dev , runtime : false } ] end","ref":"readme.html#installation","title":"Overview - Installation","type":"extras"}]